/********************************************************************
*  CardGame.java       
*
*  A simple text-based game using card objects.
*
*  @Author:  Francis Nguyen
*
*  @Version: 3/11/06
********************************************************************/

import java.util.Scanner;

import java.text.NumberFormat;

public class CardGame
{
   public static void main (String[] args)
   {
      Scanner scan = new Scanner(System.in);
      PlayingCard cardOne = new PlayingCard();
      PlayingCard cardTwo = new PlayingCard();
      String userResponse;
      double bet = 0.0, bankroll, amountWinnings = 0.0, amountLosses = 0.0;
      int numGames = 0, totWinnings = 0, totLosses = 0, totTies = 0;
      NumberFormat fmt = NumberFormat.getCurrencyInstance();
  
      System.out.println("I am going to draw a card.  You will guess if the next card is");
      System.out.println("higher or lower.  If you guessed correctly, I will add the amount");
      System.out.println("of bet to your bankroll.  If you guessed incorrectly, I will");
      System.out.println("subtract the amount of the bet from your bankroll.  If the second");
      System.out.println("card drawn is a card of the same face value but a different suit,");
      System.out.println("the game is a tie and no change should be made to your bankroll.");

      do
      {
         System.out.print("\nHow much money do you have? ");
         bankroll = scan.nextDouble();
         if (bankroll <= 0)
            System.out.println("You must enter a positive amount of money.");
      } 
      while (bankroll <= 0);
      scan.nextLine();

      do
      {
         numGames++;

         do
         {
            System.out.print("How much do you want to bet? ");
            bet = scan.nextDouble();

            if (bet > bankroll)
               System.out.println("You only have " + fmt.format(bankroll) + ". Please enter another amount.");

            if (bet >= 100)
               System.out.println("Bets are limited to less than $100.00.");

            if (bet <= 0)
               System.out.println("You must bet a positive amount of money.");
         } 
         while (bet > bankroll || bet <= 0 || bet >= 100);
         scan.nextLine();

         cardOne.drawCard();
         System.out.println("\nI drew a " + cardOne);
         System.out.print("Is the next card higher or lower? [higher/lower] ");
         userResponse = scan.nextLine();
         cardTwo.drawCard();

         do
         {
            cardTwo.drawCard();
         }
         while (cardOne.isEquals(cardTwo));

         if (cardTwo.getFace() > cardOne.getFace())
         {
            System.out.println(cardTwo + " is higher than " + cardOne);

            if (userResponse.equalsIgnoreCase("higher"))
            { 
               totWinnings++;
               amountWinnings+=bet;
               System.out.println("You won.  Add " + fmt.format(bet) + " to your bankroll.");
               bankroll+=bet;
               System.out.println("Now you have " + fmt.format(bankroll) + " left.");
            }

            if (userResponse.equalsIgnoreCase("lower"))
            {
               totLosses++;
               amountLosses-=bet;
               System.out.println("You lost.  Subtract " + fmt.format(bet) + " from your bankroll.");
               bankroll-=bet;
               System.out.println("Now you have " + fmt.format(bankroll) + " left.");
            }
         }

         if (cardTwo.getFace() < cardOne.getFace())
         {
            System.out.println(cardTwo + " is lower than " + cardOne);
            
            if (userResponse.equalsIgnoreCase("lower"))
            {
               totWinnings++;
               amountWinnings+=bet;
               System.out.println("You won.  Add " + fmt.format(bet) + " to your bankroll.");
               bankroll+= bet;
               System.out.println("Now you have " + fmt.format(bankroll) + " left.");
            }

            if (userResponse.equalsIgnoreCase("higher"))
            {
               totLosses++;
               amountLosses-=bet;
               System.out.println("You lost.  Subtract " + fmt.format(bet) + " from your bankroll.");
               bankroll-= bet;
               System.out.println("Now you have " + fmt.format(bankroll) + " left.");
            }
         }

         if (cardOne.getFace() == cardTwo.getFace())
         {
            System.out.println(cardTwo + " is equal to " + cardOne);
	    totTies++;
            System.out.println("The game is a tie and no change should be made to your bankroll.");
            System.out.println("You still have " + fmt.format(bankroll) + " left.");
         }
    
         if (bankroll >= bet)
         {
            System.out.print("\nDo you want to play again? ");
            userResponse = scan.nextLine();
         }  
      }
      while(userResponse.equalsIgnoreCase("yes") && bankroll >= bet);  

      System.out.println("\nTotal number of games played " + numGames + 
                         " games: " + totWinnings + " wins, " + totLosses + 
                         " losses, and " + totTies + " ties.");
      System.out.println("Total amount add to your bankroll " + fmt.format(amountWinnings));     
      System.out.println("Total amount subtract from your bankroll " + fmt.format(amountLosses));
      System.out.println("You have " + fmt.format(bankroll) + " left.");
   }
}